import { WebContainer } from '@webcontainer/api';
import { files } from './files';

/** @type {import('@webcontainer/api').WebContainer}  */
let webcontainerInstance;

/** @type {HTMLIFrameElement | null} */
const iframeEl = document.querySelector('iframe');

/** @type {HTMLTextAreaElement | null} */
const textareaEl = document.querySelector('textarea');

window.addEventListener('load', async () => {
  // textareaEl.value = files['index.js'].file.contents;
  // textareaEl.addEventListener('input', (e) => {
  //   writeIndexJS(e.currentTarget.value);
  // });
  const hasLoaded = document.querySelector('.container') !== null;
  if (hasLoaded) {
    return;
  }
  console.log('@hasLoaded', document.querySelector('.container'), hasLoaded);
  document.querySelector('#root')!.innerHTML = `
  <div class="container">
    <div class="editor">
      <textarea>I am a textarea</textarea>
    </div>
    <div class="preview">
      <iframe src=""></iframe>
    </div>
  </div>
`;
  console.log('@root', document.querySelector('#root'));
  console.log('@window.addEventListener', document.querySelector('#root'));

  // Call only once
  webcontainerInstance = await WebContainer.boot();
  await webcontainerInstance.mount(files);

  const exitCode = await installDependencies();
  if (exitCode !== 0) {
    throw new Error('Installation failed');
  }
  console.log('Installation successful');
  startDevServer();
});

async function installDependencies() {
  // Install dependencies
  const installProcess = await webcontainerInstance.spawn('npm', ['install']);
  installProcess.output.pipeTo(
    new WritableStream({
      write(data) {
        console.log(data);
      },
    }),
  );
  // Wait for install command to exit
  return installProcess.exit;
}

async function startDevServer() {
  // Run `npm run start` to start the Express app
  await webcontainerInstance.spawn('npm', ['run', 'start']);

  // Wait for `server-ready` event
  webcontainerInstance.on('server-ready', (port, url) => {
    console.log('@server-ready', port, url);
    const iframe = document.querySelector('iframe');
    if (iframe) {
      iframe.src = url;
    }
  });
}
